struct xv moveOL(int s, int g,struct swarm SW, struct problem pb, 
					struct param param, int strategy, double c1)
{
//----------------------------------------------- ORTHOGONAL LEARNING STRATEGY
int d;
struct position p1;
int s2;
struct xv xv;

		if(g!=s)
		{
			s2=g;
		}
		else  // If the two best previous positions are in fact the same
					// choose another one at random
		{
			new_g:
			s2=alea_integer(0,param.S-1);
			if(s2==s) goto new_g;
		}

		// Combine the two positions for orthogonal learning
		// and factor analysis (option)
		p1=orthoLearn(SW.P[s], SW.P[s2], pb, param, strategy);
		
		// Update the velocity
		for (d = 0; d < pb.SS.D; d++)
		{	
			xv.v.v[d]=xv.v.v[d] +alea(0, c1)*(p1.x[d]-SW.X[s].x[d]);
		}

		// Update the position
		for (d = 0; d < pb.SS.D; d++)
		{	
			xv.x.x[d] = SW.X[s].x[d] + xv.v.v[d];	
		}
		return xv;
	}
//==============================================================================
struct position orthoLearn(struct position P1, struct position P2, 
			struct problem pb, struct param param, int strategy)
{
	// Build a new position P by "orthogonal learning" from P1 and P2

	int contrib[DMax];
	int D=P1.size;
	int d;
	int equ;
	struct fitness f[4*DMax]; // For factor analysis
	int i;
	int j;
	struct position P, PBest;
	double S[DMax][2];
	int zTot;

	P.size=D;
	PBest.size=D;

	// ORTHOGONAL LEARNING ITSELF. Combine P1 and P2 according to orthoArray
	//printf("\nOrthog. Learning");
	// First tested position. 
	zTot=0;
	for(d=0;d<D;d++)
	{
		if(orthoArray.a[0][d]==1) 
		{
			PBest.x[d]=P1.x[d];
			zTot=zTot+1;
		}
		else PBest.x[d]=P2.x[d];
	}

	if(zTot==0) PBest.f=P2.f; // PBest=P2 => no need to re-estimate it
	else
	{
		if(zTot==D) PBest.f=P1.f;// PBest=P1 => no need to re-estimate it
		else
			PBest.f=perf (PBest, pb, 0, 0, 0,param.normalise);
	}

	f[0]=PBest.f;

	// Other positions, and keep the best
	for(j=1;j<orthoArray.size1;j++)
	{
		zTot=0;
		for(d=0;d<D;d++)
		{
			if(orthoArray.a[j][d]==1) {P.x[d]=P1.x[d];zTot=zTot+1;}
			else P.x[d]=P2.x[d];
		}

		if(zTot==0) P.f=P2.f;
		else
		{
			if(zTot==D) P.f=P1.f;
			else
				P.f=perf (P, pb, 0, 0, 0,param.normalise);
		}

		f[j]=P.f;
		if(betterThan(P.f, PBest.f)==1) 
		{ 
			PBest=P;
		}						
	}

	if(strategy==2) return PBest;

	// FACTOR ANALYSIS
	// Estimate the effect S of each "level" (2) on each "factor" (D)
	for(d=0;d<D;d++)
	{
		S[d][0]=0;
		S[d][1]=0;
		zTot=0;
		for(j=0;j<orthoArray.size1;j++)
		{
			if(orthoArray.a[j][d]==1) 
			{
				S[d][0]=S[d][0]+errorFC(f[j]); zTot=zTot+1;
			}
			else S[d][1]=S[d][1]+errorFC(f[j]);		
		}

		S[d][0]=S[d][0]/zTot;
		S[d][1]=S[d][1]/(2*D-zTot);
		//printf("\northo 81  zTot %i d %i, S0 %f S1 %f",zTot, d,	S[d][0], S[d][1]);
	}

	// Build the best combination (for minimisation)
	zTot=0;
	for(d=0;d<D;d++)
	{
		if(S[d][0]<S[d][1]) 
		{
			P.x[d]=P1.x[d];
			zTot=zTot+1;
			contrib[d]=1;
		}
		else {P.x[d]=P2.x[d];contrib[d]=0;}
	}

	if(zTot==0) P.f=P2.f;
	else
	{
		if(zTot==D) P.f=P1.f;
		else
		{
			// Already evaluated?
			for(j=0;j<orthoArray.size1;j++)
			{
				equ=0;
				for(d=0;d<D;d++)
				{
					if(contrib[d]==orthoArray.a[j][d]) equ=equ+1;
				}
				if(equ==D) // Already evaluated. Can not be better than PBest
				{
					return PBest;
				}
			}
			P.f=perf (P, pb, 0, 0, 0,param.normalise);
//printf("\northo 121 P.f %f",P.f.f[0]);
		}
	}
	compare:

		// Keep the best
		if(betterThan(P.f, PBest.f)==1) 
	{
		//printf("\northo. Fact. Analysis %f => %f",PBest.f.f[0], P.f.f[0]);
		PBest=P;
	}

		return PBest;

}
//==============================================================================
void orthoGenerate(int D)
{
	// Generate the binary orthoArray[2*D][D]  (global variable)
	int a[D];
	int array[2*DMax][DMax];	
	int dupli[2*DMax];
	int d;
	int equ;	
	int j;
	int k;
	int scan;

	int option=-1;

	// TO DO    should be improved


	orthoArray.size2=D; // Number of columns

	switch(D)
	{
		case 2:
		f_ortho=fopen("OA_2.txt","r"); 
		option=0;
		break;

		case 3:
			f_ortho=fopen("OA_3.txt","r"); 
			option=0;
			break;

		case 4:
			f_ortho=fopen("OA_4.txt","r"); 
			option=0;
			break;
			
			case 5:
			f_ortho=fopen("OA_5.txt","r"); 
			option=0;
			break;
			
			case 6:
			f_ortho=fopen("OA_6.txt","r"); 
			option=0;
			break;
			
						case 7:
			f_ortho=fopen("OA_7.txt","r"); 
			option=0;
			break;

		case 8:
			f_ortho=fopen("OA_8.txt","r");
			option=0; 
			break;
		
				case 9:
			f_ortho=fopen("OA_9.txt","r");
			option=0; 
			break;
		
	// NOTE: For dimension >=10, you may also try the "generated" OA
	// Just comment the lines below, or set option=-1
	/*	
		case 10:
		f_ortho=fopen("OA_10.txt","r");
		option=0;
		break;
	*/	
				case 11:
		f_ortho=fopen("OA_11.txt","r");
		option=0;
		break;

		case 12:
			if(alea_integer(0,1)==0) f_ortho=fopen("OA_12a.txt","r"); 
			else f_ortho=fopen("OA_12b.txt","r"); 
			option=0;
			break;
			
		case 13:
		f_ortho=fopen("OA_13.txt","r");
		option=0;
		break;

		case 14:
		f_ortho=fopen("OA_14.txt","r");
		option=0;
		break;

		case 15:
		f_ortho=fopen("OA_15.txt","r");
		option=0;
		break;

		case 16:
			k= alea_integer(1,5);
			switch(k)
		{
			case 1: f_ortho=fopen("OA_16a.txt","r"); break;
			case 2: f_ortho=fopen("OA_16b.txt","r"); break;
			case 3: f_ortho=fopen("OA_16c.txt","r"); break;
			case 4: f_ortho=fopen("OA_16d.txt","r"); break; 
			case 5: f_ortho=fopen("OA_16e.txt","r"); break;
		}
			option=0;
			break;
			
		case 17:
		f_ortho=fopen("OA_17.txt","r");
		option=0;
		break;
		
		case 18:
		f_ortho=fopen("OA_18.txt","r");
		option=0;
		break;
		
		case 19:
		f_ortho=fopen("OA_19.txt","r");
		option=0;
		break;
		
		case 20:
		f_ortho=fopen("OA_20.txt","r");
		option=0;
		break;
		
	}

	switch(option)
	{		
		default: // Read a big one, select and compact
			// Read the orthogonal array
			f_ortho=fopen("ortho.txt","r"); 
			printf("\nRead a big orthogonal array, and extract");
			printf("\nWARNING. The result is usually not a perfect orthogonal array");

		for(j=0;j<2*DMax;j++) 
		{
			for(d=0;d<DMax;d++)
			{
				scan=fscanf(f_ortho,"%i",&k);			
				array[j][d]=k;	
			}		
		}		

		// Select at random D columns
		a[0]=alea_integer(0,D-1);

		for(d=1;d<D;d++) 
		{
			new_a:
				a[d]=alea_integer(0,D-1);
				// Check if already chosen
				for(k=0;k<d;k++) if(a[d]==a[k]) goto new_a;	
		}

		// Put the D columns into orthoArray
		for(j=0;j<2*DMax;j++)
		{
			for(d=0;d<D;d++) 
			{
				orthoArray.a[j][d]=array[j][a[d]];	
			}	
		}

		// Mark duplicate
		for(j=1;j<2*DMax;j++)
		{		
			dupli[j]=0;
			for(k=0;k<j;k++)
			{
				equ=0;
				for(d=0;d<D;d++) if(orthoArray.a[k][d]==orthoArray.a[j][d]) equ=equ+1;
				if(equ==D) {dupli[j]=1; break;}
			}
		}	

		// Compact
		orthoArray.size1=1;
		for(j=1;j<2*DMax;j++)
		{
			if(dupli[j]==1) continue;
			if(orthoArray.size1>=2*D) break;

			for(d=0;d<D;d++)
			{
				orthoArray.a[orthoArray.size1][d]=orthoArray.a[j][d];
			}
			orthoArray.size1=	orthoArray.size1+1;	

		}
		break;

		case 0: // Read

		printf("\nRead orthogonal array");
		scan=fscanf(f_ortho,"%i",&k);
		orthoArray.size1=k;
		printf( " size %i",orthoArray.size1);

		for(j=0;j<orthoArray.size1;j++) 
		{				
			for(d=0;d<D;d++)
			{
				scan=fscanf(f_ortho,"%1i",&k);			
				orthoArray.a[j][d]=k;
			}		
		}	
		break;
	}

		// Display the array
		printf("\nOrthogonal array");
		for(j=0;j<orthoArray.size1;j++)
	{
		printf("\n");
		for(d=0;d<D;d++) printf("%i ",orthoArray.a[j][d]);
	}	

}