struct exploit exploitArea(struct swarm SW, struct SS SS, struct param param,
 int update, double explRate[],double rho0)
{
	// Define the exploitation area
	int d;
	int D=SW.X[0].size;
	struct exploit ex; // local search space (D, max, min, quantum)
	// around each local best
	int i;
	struct lBest lB[SMax+2];  
	int nbLBest; // Number of different local bests
	double rho; // Define what "around" means. Should be <= 0.5
	int s;

if(update==0) 
{
		switch(param.explOption)
		{
			default: 
			rho=param.size_LEA;
			break;
	//		case 1: // Variable. TO DO
				break;
	//		case 2: // Variable. TO DO
				break;
			case 3:
				if(alea(0,1)<0.5) rho=param.size_LEA;  else rho=1./param.S;
				break;
			case 4:
				rho=alea(0,param.size_LEA);
				break;
			case 5:
				rho=fabs(alea_normal(1./param.S,param.size_LEA));
				break;
		}
}
else
{
		switch(param.explOption)
		{
			default: // Keep constant *
			rho=rho0;
				break;

			case 1:
				rho=pow(pow(rho0,D)+explRate[1]-explRate[0],1./D);
				break;

			case 2:
				if(explRate[1]-explRate[0]>0)
			{
				rho=rho0*pow( 1-(explRate[1]-explRate[0])/(1-explRate[0]),1./D);
			}
				else
			{
				rho=pow(pow(rho0,D) + 
				    (explRate[1]-explRate[0])*(pow(rho0,D)-1)/explRate[1],1./D);
			}
				break;
			case 3:
				if(alea(0,1)<0.5) rho=param.size_LEA;
				else rho=1./param.S;
				break;

				case 4: // Random Uniform
					rho=alea(0,param.size_LEA);
				break;

				case 5: // Random Gauss
				rho=fabs(alea_normal(0,param.size_LEA)); 
				if (rho>1)  rho=1;
				break;
		}
}

	/*
	 For each local best, define the local exploitation area (LEA)
	 (hyperparallelepid "around" it.
	  */

	// Build the list of local bests (index, coordinates) + min + max
	i=1;
	for(s=0;s<SW.S;s++)
	{
		if(SW.lBest[s]==0) continue;

		lB[i].rank=s;
		for (d=0;d<SS.D;d++) lB[i].x[d]=SW.Pp[s].x[d];
		i=i+1;
	}

	lB[0].rank=-1; // "Left" border point
	lB[i].rank=-2; // "Right" border point

	for (d=0;d<SS.D;d++) 
	{
		lB[0].x[d]=SS.min[d];
		lB[i].x[d]=SS.max[d];
	}

	nbLBest=i-2; // Number of local bests

	// For each dimension
	// Sort the list 
	// Define the intervals
	for(d=0;d<SS.D;d++)
	{
		// Sort the list by ascending order
		dLBest=d; // Global variable. Needed for compareLBest
		qsort(lB,nbLBest+2,sizeof(lB[0]),compareLBest);

		// For each local best
		// add the interval in dimension d that defines the LEA

		for (i=0;i<SW.S;i++) 
		{
			ex.rank[i]=0; // Means N/A
			ex.exI[i].D=SS.D; // For future use (local search)
			ex.exI[i].q.size=SS.D; // "
		}

		for (i=1;i<nbLBest+2;i++)
		{		
			ex.rank[lB[i].rank]=1;

			ex.exI[lB[i].rank].min[d]=lB[i].x[d]-rho*(lB[i].x[d]-lB[i-1].x[d]);  
			ex.exI[lB[i].rank].max[d]=lB[i].x[d]+rho*(lB[i+1].x[d]-lB[i].x[d]);
			ex.exI[lB[i].rank].q.q[d]=SS.q.q[d];
		}
	}
	ex.rho=rho;
	return ex; 
}
//==================================================
double explNb(struct swarm SW, struct exploit ex )
{
	// For each position
	// check if it is inside a LEA
	int d;
	int Dim;
	int exNb=0;
	double rate;
	int i;
	int inExArea;
	int s;

	Dim=ex.exI[0].D;

	for (s=0;s<SW.S;s++) // For each position
	{	
		for(i=0;i<SW.S;i++) // For each "exploitation area" (hyperparallelepid)
		{
			if(ex.rank[i]<=0) continue;

			inExArea=1;
			for(d=0;d<Dim;d++) // For each "exploitation interval"
			{
				if(SW.X[s].x[d]<=ex.exI[i].min[d] || SW.X[s].x[d]>= ex.exI[i].max[d])
				{inExArea=0; break;}		
			}
			if(inExArea==1)
			{

				exNb=exNb+1;
				break; // Counted just once
			}
		}
	}
	rate=(double)exNb/SW.S;

	return rate;
}
// ====================================================
struct xv drawLEA(struct param param, struct swarm SW, int s0, int g, 
 struct exploit ex, struct krigin krigin )
{
		// Force a new position
int d;
int dim=SW.X[0].size;
int m;
int s;
double zz,zzz;
struct xv xv;

	xv.v=SW.V[s0]; // The velocity should be modified too, but in practice
							// it seems it does not change anything
	xv.x.size=dim;
					
	switch(param.draw_LEA)
			{
				default:
				case 0: // middle of the LEA			 
				for (d = 0; d < dim; d++)
				{			
					xv.x.x[d]=
						0.5*(ex.exI[g].max[d]+ex.exI[g].min[d]);
				}

			 break;

				case 1: // Uniform
					for (d = 0; d < dim; d++)
					{			
						xv.x.x[d]=ex.exI[g].min[d]+
							alea(0,1)*(ex.exI[g].max[d]-ex.exI[g].min[d]);
					}
				break;
				
				case 2: // Gaussian
				for (d = 0; d < dim; d++)
				{			
					zz=0.5*(ex.exI[g].max[d]-ex.exI[g].min[d]);
					zzz=alea_normal(0,1.48*zzz); // For a fifty-fifty probability distribution
					if(fabs(zzz)>zz) 
					{ if (zzz>0) zzz=zz; else zzz=-zz;};

					xv.x.x[d]=
					zzz+0.5*(ex.exI[g].max[d]+ex.exI[g].min[d]);
				}

				break;
				case 4: // Krigin (EXPERIMENTAL)
#include "krigin.c"

					break;

			} // End of switch draw_LEA

				explForced=explForced+1;
						xv.x.forced=1;
			return xv;
	}