struct xv move(struct result R, int s, int g, struct problem pb,
				struct param param,int stagnation)
{
	double c1,c2;
	int d;
	struct velocity GX;
	double norm1, norm2;
	struct velocity PX;
	struct velocity V;
	int randType;
	double randGamma;
	double vDamp=1;
	struct xv xv;
	double w;
	double zz,zzz;

	xv.x.size=pb.SS.D;
	xv.v.size=pb.SS.D;
	xv.x.f=R.SW.X[s].f; // In case the position won't be re-evaluated
	PX.size=pb.SS.D; 
	GX.size=pb.SS.D;
//if(param.OW>0 ) printf("\n OW %i",param.OW);
// if(param.OL>0 ) printf("\n OL %i",param.OL); 

	

	w=R.SW.w[s];
	c1=R.SW.c1[s];
	c2=R.SW.c2[s];

	// Update the velocity
	for (d = 0; d < pb.SS.D; d++)
	{
		xv.v.v[d]=vDamp*w*R.SW.V[s].v[d];
	}

	// --------------------------------------------------------NORMAL PSO STRATEGY
	// Exploration tendency

	// if(posPrev.f>pos0.f) vDamp=0; // If improvement, slow down
	// else vDamp=1;


	// Prepare Exploitation tendency
	for (d = 0; d < pb.SS.D; d++) // p-x
	{
		PX.v[d]= R.SW.P[s].x[d] - R.SW.X[s].x[d];
	}				

	if(g!=s)
	{
		for (d = 0; d < pb.SS.D; d++) // g-x
		{
			GX.v[d]= R.SW.P[g].x[d] - R.SW.X[s].x[d];
		}
	}

	// Exploitation tendencies
	switch(R.SW.R[s])
	{			
		default: 
		case0:
			for (d = 0; d < pb.SS.D; d++)
		{	
			zz=alea(0, c1);
			xv.v.v[d]=xv.v.v[d] +	zz*PX.v[d];

			if(param.nonLinear>0)	 xv.v.v[d]=xv.v.v[d] +
				zz*PX.v[d]*pow(PX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
			// zz*pow(PX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
		}

			if (g!=s) // If the best neighbour is not the particle itself
		{
			for (d = 0; d < pb.SS.D; d++)
			{	
				zz=alea(0,c2);
				xv.v.v[d]=xv.v.v[d] +	zz * GX.v[d];	

				if(param.nonLinear>0)	xv.v.v[d]=xv.v.v[d] +
					zz*GX.v[d]*pow(GX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
				//zz*pow(GX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
			}
		}
			break;	

			case 1:		// Gaussian distribution	
				for (d = 0; d < pb.SS.D; d++)
		{	
			xv.v.v[d]=xv.v.v[d]
				+	c1*alea_normal(alea(0,1), param.sigma)*PX.v[d];

		}

			if (g!=s)
		{
			for (d = 0; d < pb.SS.D; d++)
			{								
				xv.v.v[d]=xv.v.v[d]
					+	c2*alea_normal(alea(0,1), param.sigma) * GX.v[d];			
			}
		}
			break;

			case 2: // Decreasing function of the 1D distance 
				// (see also the parameter distPow)
			case2: 
			for (d = 0; d < pb.SS.D; d++) // Uniform
		{	
			xv.v.v[d]=xv.v.v[d] +	c1*alea(0, 1)*PX.v[d];
		}

			if (g!=s) // If the best neighbour is not the particle itself
		{
			for (d = 0; d < pb.SS.D; d++) // Distance decreasing
			{	
				zz=fabs(GX.v[d])/(pb.SS.max[d]-pb.SS.min[d]);// Relative distance
				zzz=(1-zz); 

				xv.v.v[d]=xv.v.v[d] 
					+	c2*alea(0,1) *pow(zzz,param.distPow) *GX.v[d];			
			}
		}
			break;

		case 3:
			if(alea(0,1)<0.5) goto case0; 
			goto case2;
			
		case 40:  // Use hyperspheres
		randType=0;
		case40:
		zz=c1*coeffSC;
		norm1=zz*normL(PX,2); // Radius

		// Offset radius 
		for(d=0;d<pb.SS.D;d++) V.v[d]=zz*PX.v[d];
		// Random in the hypersphere center 0, radius norm1
		PX=alea_sphere(pb.SS.D,0,norm1,randType,randGamma);	

		// Displacement
		for(d=0;d<pb.SS.D;d++)
		{
			xv.v.v[d]=xv.v.v[d]+PX.v[d]+V.v[d];
		}
		
		if(s!=g)
		{
			zz=c2*coeffSC;
			norm2=zz*normL(GX,2);
			for(d=0;d<pb.SS.D;d++) V.v[d]=zz*GX.v[d];	
			GX=alea_sphere(pb.SS.D,0,norm2,randType,randGamma);

			for(d=0;d<pb.SS.D;d++)
			{
				xv.v.v[d]=xv.v.v[d]+ GX.v[d]+V.v[d];				
			}
		}
		break;	
		
		case 41: // Note. A theoretical analysis is needed here, to derive the
						// "right" randGamma
		randType=1;
		randGamma=0.5; 
		goto case40;
	}

	// Update the position
	for (d = 0; d < pb.SS.D; d++)
	{	
		xv.x.x[d] = R.SW.X[s].x[d] + xv.v.v[d];	
	}

	return xv;
}
#include "moveOW.c"
#include "moveOL.c"
#include "moveNisB.c"