/* -----------------------------------------------------
 PARAMETERS and OPTIONS (more or less alphabetical order)
 * = "suggested value"
 
 WARNING Some combinations of options are "stupid".
  Sometimes I check the possible inconsistencies, sometimes not. Be careful.
 ---------------------------------
 */



switch(SPSO)
{

	default: case 0:

		break;

		case 1: // Simulate SPSO07

#include "paramSPSO07.c"	
			goto warnings;

		case 2: // Simulate SPSO-BK

#include "paramSPSOBK.c"
			goto warnings;

}

param.C1=0; // C1
// (SPSO07) 0 => constant c1
// 1 => random uniform
// See also initC1 

param.C2=0; // C1
// (SPSO07) 0 => constant c2
// 1 => random uniform
// See also initC2	

param.choose_LEA=0; // CH
// 0 => no LEA (SPSO 2007)
// 1 => LEA of the particle (=> high exploitation rate)
// 2 => best LEA (=> lower exploitation rate)
// Note: the exploitation rate is also depending on param.sizeLEA
// 		param.force_LEA, param.size_LEA, and param.explOption
//			(see predefined "automatic" values below)

param.clamping =1; // code CL (for "clamping")
// 0 => no clamping AND no evaluation. WARNING: the program
// 				may NEVER stop 
//(SPSO 07) *1 => classical. Set to bounds, and velocity to zero
// 2 => no clamping, no evaluation, velocity modified. 

param.draw_LEA= 0;  // D  Where in the LEA?
//* 0 => middle
// 1 => uniform distribution
// 2 => Gaussian distribution
// 3 => 0 + 1
// 4 => Kriging (EXPERIMENTAL)
// Note: inactive if choose_LEA=0

//	param.explOption (see below "automatic" values)
// 		0 => constant relative size of the exploitation area
// 		1 => variable
// 		2 => variable
// *	3 => alternative {size_LEA,1/S}
//		4 => random uniform [0,param.size_LEA]
//		5 => random Gauss (1/S, size_LEA)

//	param.force_LEA (see below "automatic" values)
// Define the rate exploit/exploration you want
// Useful only if choose_LEA > 0

param.inheritance=0.0; // INH. Inheritance of coefficients w, c1, and c2
// A particle may inherit these coefficients of the best one in its neighbour
// Needs of course variable w, c1, c2  (param.C1, param.C2, param.W)
// Notes:
// - should be used with param.mutation
// - should be used with param.W, param.C1, param.C2
// Suggested value: 0.05. TO DO: random in [0.05,1]

param.init=0; // P.  Initialisation of the positions
// -1 => read from file f_init (be sure it is consistent with the other data)
//(SPSO 07) 0 => on each dimensionrandom position (uniform U(xmin,xmax))
// 1 => random position (centre biased)
// 2 => (improved) Hammersley
// 3 => random (uniform) or Hammersley
// 4 => on "discrete" regular points on each dimension
//      Needs the parameter pb.nb. Normally used only when param.init=-1
// 5 =>  random position (centre biased), 2
// 6 => on the boundaries
// 7 => 5 and 6
// 8 => in a non searched area
// 14 => special init for polygon problem

param.topology=4; // T
// (SPSO 07) 0 => random links after unsuccessful iteration(s)
// 1 => random links after successful iteration(s)
// 2 => 0 or 1, at random before each run
// 3 => like 0, but the underlying distribution is not uniform
//      It depends on the "confidence" table.
//			Suggestion: initSelf=0, and K>3
//* 4 => variable ring
// 5 => fixed ring

param.topolInit=0; 	// 0 => reinit after unsuccessful iterations
										// 1 => the contrary

param.topolSelf=1; // TS
// (SPSO07) 1 => each particle always informs itself
// 					0 => not always		

//param.topolLinkNbMax=1;  // TLM
// 0 => Swarm_size/2
//  -1 => 1/(2*p)
// n => check if restructure, every n iterations
// (SPSO 07) 1 => after each iteration
// 99 => Let the program compute it (see below) 

param.initVel=5; // V. Initialisation of the velocity for particle whose position is X
// 0 => on each dimension U(xmin,xmax) -U(xmin,xmax)
// * 1 => on each dimension U(xmin,xmax) - X(d)
// 2 =>  Y - X, where Y is the initial position of another particle, chosen at random
// 3 => set to zero
// 4 => either 1 or 2
// *(SPSO 07) 5 => on each dimension 0.5*( U(xmin,xmax) -X(d)) 

param.K=3; //3; 	// For the probabilistic size of the neighbourhood.
// This is more or less the mean size (but not exactly)

param.mutation[0]=0.0; //M.  0.01  Probability of mutation for w
param.mutation[1]=0.0;	// ... for c1
param.mutation[2]=0.0;	// ... for c2
// Notes
// - hard-coded functions in PSO(). Could easily be modified
// - should be used with param.inheritance


param.nonLinear=0; // NL
// 0 => nothing special (SPSO07)
// 1 => non linear velocity update equation
// WARNING. For the moment, valid only with param.R=0
param.nonLinearCoeff[0]=2; // a1
param.nonLinearCoeff[1]= 0; // a2 
param.nonLinearCoeff[2]= 0; // a3

param.normalise =0; // NR
// (SPSO07) 0 => real search space
// 1 => search space normalised as [0,1]^D
// Should change absolutely nothing. If you note any difference, it means
// that the generator of pseudo-random numbers is biased.
// However, it may be useful for fair comparisons
// WARNING. Not compatible with the Cellular phone problem

param.opposite=0; // O
// (SPSO07) 0 => nothing special
// 1 => take the "opposite" of the new position


param.quant=0; //Q. For variable quantisation. See quantAdapt()
// (SPSO07) 0 => do nothing (constant quantisation)
// 1 => adaptive 
// 2 => decreasing

param.R=0; // R. Kind of distribution to use in the velocity update equation
//WARNING. Not all of these options have been carefully tested
// (SPSO 07) 0 => uniform distribution in [0,1]. See param.nonLinear, though
// 1 => like 0, but Gaussian distribution	
//* 2 => decreasing function of the 1D distance (see also the parameter distPow)
//* 3 => either 0 or 2
// 40 => by using hyperspheres (quasi non-sensitivity to rotation). Uniform distribution
// Note: as most other parameters, it has no effect if NisB>0
// It works better when the search space is a hypercube.
// If not, it would be probably a good idea to use "normalise"
// 41 => like 40, but Gaussian distribution

param.sigma=1./sqrt(12); // Standard deviation for Gaussian distribution
// Useful only if R=1 
//	param.size_LEA;// Define the initial (relative) size of the exploitation area
// Useful only if choose_LEA > 0
param.distPow=2; // Useful for some R options
// See also param.aroundNb

param.rand=0; // r
//* 0 => KISS pseudo-random number generator. 
// 1 => the one of your compiler
//	Note: Theoretically, the sequence of pseudorandom numbers generated by KISS
// 				should be exactly the same on any computer. In practice, it is not true
//				Depending on the machine, the sequence may differ after a while
//				(numerical instability)

param.randOrder=1; // O
// 0 => at each iteration, particles are modified
//     always according to the same order 0..S-1 
// *(SPSO 07) 1 => at each iteration, particles numbers are
//								randomly permutated  

param.select=0.000; // SL. In [0,1] The select*S worst particles are reinitialised
// If >0, at least one particle is reinitialised. So, to be sure to have just one
// particle, a simple way it to set it to a very small value, say 0.0001
// Suggested value: so that select*S = D. => double(param.D)/(10+2*sqrt(param.D));
// (SPSO 07) 0 

param.stop = 0;	// Stop criterion
// 0 => error < pb.epsilon  
// 1 => eval = pb.evalMax	 
// WARNING. When the variance of the success rate is quite large,
// using options 0 or 1 may give different results, unless the number of runs
//  is very high (typically at least 500)

param.strat[0]=0; //  First strategy
// 0 => PSO
// 1 => Nearer Is Better
// 2 => Orthogonal Learning
// -2 => Orthogonal Learning + Factor Analysis
// 3 => Orthogonal Walk. WARNING. See the hard coded parameters in 
//			moveOW.c, in particular "effort" and "method"
// 4 => pf-PSO (Ramana Murthy)  **** TEST
//       on functions 4, 102, 8, 9  => BAD (0% for all)

param.strat[1]=0; // Second strategy 
// NOTE: if you don't want to use two strategies, you have to set it
// equal to the first one
// Suggestion (0,-2)

param.stratOnce=0; // 1 => The first strategy is used just once by each particle
// After that, switch to the second one 

param.stratPop=1; // Rate of particles that are initialised with the first 
// strategy

param.effort=0.5; // Rate of fitness evaluations used by OW

param.OWmethod=0; 
//* 0 => at random, always move for any direction
//* 1 => at random, may not move for some directions
//? 2 => using the orthogonal array	

param.spreadProba=0.9; // We want that the probability for a particle to be
											// informed my any other one after T time steps
											// is at least spreadProba. Then T is automatically
											// computed depending on the topology	
											// Particular case: set to zero => T=1								

param.stagType=0; // 0 => stagnation is not taken into account
// 1 => stagnation if no improvement of the position
// 2 => stagnation if no improvement of the previous best
// 3 => stagnation if no improvement of the global best

param.stagRate=0; // When param.stagType=3, rate of particles whose strategy
// is modified
// Note: even if the rate is set to zero,
// the worst particle is re-initialised


param.NisB = 0 ; // In [0,1]. Useful only for NisB strategy
// Let p be a "good" position, and p' the nearest other
// "good" one. Let's suppose f(p) < f(p')
// The next point will be drawn at random in the hypersphere
// center p, radius = dist(p,p')*pow(param.NisB,1/Dimension)
// Note: as this strategy makes use of hyperspheres,
// it works better when the search space is a hypercube.
// If not, it would be probably a good idea to use "normalise"

param.swarmVar=1; // 0 => constant swarm size
									// 1 => variable swarm size

param.W=0; // W
// (SPSO 07) 0 => classical (just one constant w)
// 1 => constant w0 or random w in [w0,w1], according to w0Rate
// 2 => idem, but non uniform w
// 3 => random uniform w in a small interval
// 4 => random in a big interval (forced "scout" particle)
// 5 => random uniform + edge of chaos (c1 and c2 are depending on w)
// See also param.scout below
// See also initW 

//------------------------------------------- For the curve "fitness vs FE"
FEmaxSize=20;// If >0, save info in order to plot the curve (success_rate vs FEmax)
for(n=0;n<FEmaxSize;n++)

//FEmax[n]=5000+5000*n; // Rosenbrock F1
// FEmax[n]=500+500*n; // Tripod
FEmax[n]=1000+1000*n; // Compression spring, Gear train, Cellular phone


// -------------------------------------------------------------AUTOMATIC VALUES
// You may modify them, if you really want to ...

//param.S = (int) (10 + 2 * sqrt(pb.SS.D));	// Swarm size. Formula A 
param.S = (int) (27 + 2 * sqrt(pb.SS.D));	// Swarm size. Formula B 
//param.S=30;
//if(param.swarmVar==1) param.S=pb.SS.D+1;
// Note: 	of course, you can modify it for a specific problem.
//				You should be aware, though, that this value is an approximation
//			 	given by a mathematical analysis: it is robust 
//				(on a large set of problems, the averaged result is good). 

param.p=1-pow(1-(double)1/(param.S),param.K);
// Note: for global best topology, directly set p to 1
//        and set orthoApply to any value you want (suggested: 5)

#include "paramAuto.c"

// According to Clerc's Stagnation Analysis
param.w[0] = 1 / (2 * log ((double) 2)); // 0.721
param.c1 = 0.5 + log ((double) 2); // 1.193

/*
 // Standard PSO 2006
 param.w[0]= 0.729 ; // Just a rule of thumb, so it can be slightly modified
 param.c1=(param.w[0]+1)*(param.w[0]+1)/2; // Standard PSO 2006 
 */

param.c2=param.c1; 
param.w[1]=1;


/*   Questionable (very bad on some functions)
 // According to Nayan R. Samal, Amit Konar, Swagatam Das, Ajith Abraham
 // (Closed Loop Stability Analysis)
 param.w[0]=0.6;
 param.c1=0.103;
 param.c2=2.897;
 param.w[1]=1;
 */

/*
 // Anarchic PSO
 param.w[0]=1 / (2 * log ((double) 2)); // With param.W=5;
 param.w[1]=1 ;
 */

param.w0Rate=1./param.S; //   In order to have about one "scout particle" 
//param.w0Rate=1./(param.p*param.S);
// In order to have (in average) one "scout particle" in each neighbourhood

param.scout=1./param.S; // Rate of scout particles in [0,1] (for param.W=4)	

param.aroundNb=pb.SS.D+1; // Warning: will be different for localSearch=6 (kriging)

switch (param.choose_LEA)
{
	default: // 0. Nothing special
		break;

	case 1:	// LEA of the particle (i.e. around its own previous best)
		param.force_LEA=0.5; //1./param.S; 
	param.size_LEA=1./3;
	break;

	case 2: // LEA of the local best  (i.e. around the best previous best
		// in the neighbourhood of the particle)
		param.force_LEA=0.5; //1./param.S; 
	param.size_LEA=0.5; 
	param.explOption=3;
	break;
}
//------------------------------------------------ Some other assignements
switch(param.W) 
{
	default: case 3: wSize=1; break;
	case 1: case 2: case 4: wSize=2; break;
}	

//---------------------------------------------------------- WARNINGS and ERRORS
warnings:
if(param.clamping==0)
{
	printf("\nWARNING. No clamping => a run may never stop!");
}

if(param.clamping==2)
{
	printf("\nWARNING. No clamping => a run might never stop!");
}


if (runMax > RMax)  // Maximum number of runs
{
	runMax = RMax;
	printf("\nWARNING. No more than %i run",RMax);
}

if (param.S > SMax)
{ 
	param.S = SMax;
	printf("\nWARNING. The swarm size can not be more than %i",SMax);
}

if(param.nonLinear>0 && param.R>0)
{
	printf("\nWARNING. param.nonLinear=%i will have no effect with param.R>0",
	    param.nonLinear);
}

if(param.normalise>0 && functionCode==10)
{
	ERROR("\nERROR. The normalise option is not compatible with the Cellular phone problem");
}

if( (abs(param.strat[0])==2 || abs(param.strat[1])==2) && pb.SS.D==1)
{
	ERROR("\nERROR. Orthogonal learning is not possible on dimension 1");
}

	if(param.strat[0]!=param.strat[1] && param.stratOnce==1) 
		printf("\nWarning: param.stratOnce is set to 1");
